﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
namespace DTGautoTxt
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        //initializes new instance 
        SqlConnection con = new SqlConnection();
        SqlDataAdapter da = new SqlDataAdapter();
        SqlCommand cmd = new SqlCommand();
        DataTable dt = new DataTable();


        private void Form1_Load(object sender, EventArgs e)
        {
        //'declaring a new textbox column in the datagridview
        DataGridViewTextBoxColumn txt = new DataGridViewTextBoxColumn();
        txt.Name = "Books Name";
        txt.Width = 250;
        //'adding a textbox column in the datagridview
        dataGridView1.Columns.Add(txt); 
            
            //set a connection between SQL server and Visual C#
            con.ConnectionString = "Data Source=.\\SQLEXPRESS;Database=dbbooks;trusted_connection=true;";
        }
 
        private void dataGridView1_EditingControlShowing(object sender, DataGridViewEditingControlShowingEventArgs e)
        {


            //opening connection
            con.Open();
            try
            {
                //initialize a new instance of sqlcommand
                cmd = new SqlCommand();
                //set a connection used by this instance of sqlcommand
                cmd.Connection = con;
                //set the sql statement to execute at the data source
                cmd.CommandText = "SELECT * FROM tblbooks";
                //initialize a new instance of sqlDataAdapter
                da = new SqlDataAdapter();
                //set the sql statement or stored procedure to execute at the data source
                da.SelectCommand = cmd;
                //initialize a new instance of DataTable
                dt = new DataTable();
                //add or resfresh rows in the certain range in the datatable to match those in the data source.
                da.Fill(dt);


                foreach (DataRow r in dt.Rows)
                {
                    //e represent the editing control in the datagridview
                    //the condition is, if the type of e is combobox then set your code for autocomplete
                    if (e.Control is TextBox)
                    {
                        DataGridViewTextBoxEditingControl txt = e.Control as DataGridViewTextBoxEditingControl;
                         //adding the specific row of the table in the AutoCompleteCustomSource of the textbox
                        txt.AutoCompleteCustomSource.Add(r.Field<string>("BooksName"));
                        //set the propety of a texbox to autocomplete mode.
                        txt.AutoCompleteMode = AutoCompleteMode.SuggestAppend;
                        txt.AutoCompleteSource = AutoCompleteSource.CustomSource;
                    }

                }
            


            }
            catch (Exception ex)
            {
                //catching error 
                MessageBox.Show(ex.Message);
            }
            //release all resources used by the component
            da.Dispose();
            //closing connection
            con.Close();



          
        }
    }
}
